#!/bin/bash


# 关键路径定义
BACKUP_FILE="/usr/share/dbus-1/system-service/com.kylin.softwarectrl.service.bak"
STATUS_FILE="/var/lib/softwarectrl_prepared.status"

# 仅在存在备份文件且无预处理标记时恢复（说明异常中断）
if [ -f "$STATUS_FILE" ]; then
  echo "检测到升级异常中断，开始恢复"
  
  # 恢复服务文件
  mv "$BACKUP_FILE" /usr/share/dbus-1/system-service/com.kylin.softwarectrl.service
  
  # 恢复服务状态
  systemctl enable dbus-com.kylin.softwarectrl.service
  systemctl start dbus-com.kylin.softwarectrl.service
  
  # 恢复防卸载机制（若状态为临时关闭）
  chmod +w /etc/dpkg/udeblist.xml
  sed -i 's/bw_status="0"/bw_status="2"/g' /etc/dpkg/udeblist.xml
  rm -f "$STATUS_FILE"
  
  echo "异常恢复完成，备份文件已清理"
fi