#!/bin/bash

if [ -f /sys/kernel/security/kysec/status ];then
	kstatus=`cat /sys/kernel/security/kysec/status`
	if [ $kstatus -eq 2 ];then
		echo "2" > /etc/kysec/kysec_s
		if [ `echo $?` -ne 0 ];then
			echo "kysec的状态记录失败"
			echo "2" > /etc/kysec/kysec_s
		fi

		if [ -f /sys/kernel/security/kysec/exectl ];then
			exectl_status=`cat /sys/kernel/security/kysec/exectl`
			if [ $exectl_status -ne 0 ]; then
				echo "0" > /sys/kernel/security/kysec/exectl
			fi
		fi

		if [ -f /sys/kernel/security/kysec/netctl ];then
			netctl_status=`cat /sys/kernel/security/kysec/netctl`
			if [ $netctl_status -ne 0 ];then
				echo "0" > /sys/kernel/security/kysec/netctl
			fi
		fi
	fi
fi

if [ -f  /sys/kernel/security/kysec/iptables ];then
	iptable_status=`cat /sys/kernel/security/kysec/iptables`
	if [ $iptable_status -eq 1 ];then
		echo "1" > /etc/kysec/iptable_s
		if [ `echo $?` -ne 0 ];then
			echo "防火墙的状态记录失败"
			echo "1" > /etc/kysec/iptable_s
		else
			echo "0" > /sys/kernel/security/kysec/iptables
			if [ `echo $?` -ne 0 ];then
				echo "iptable状态设置失败"
				echo "0" > /sys/kernel/security/kysec/iptables
			fi
		fi
	fi
fi

if [ -f  /sys/kernel/security/kysec/ppro ];then
	ppro_status=`cat /sys/kernel/security/kysec/ppro`
	if [ $ppro_status -eq 1 ];then
		echo "1" > /etc/kysec/ppro_s
		if [ `echo $?` -ne 0 ];then
			echo "进程保护的状态记录失败"
			echo "1" > /etc/kysec/ppro_s
		else
			echo "0" > /sys/kernel/security/kysec/ppro
			if [ `echo $?` -ne 0 ];then
				echo "进程保护的状态设置失败"
				echo "0" > /sys/kernel/security/kysec/ppro
			fi
		fi
	fi
fi

# 定义状态文件（标记预处理是否完成）
STATUS_FILE="/var/lib/softwarectrl_prepared.status"

# 异常处理：中断时清理状态
trap 'cleanup' INT TERM
cleanup() {
  [ -f "$STATUS_FILE" ] && rm -f "$STATUS_FILE"
}

# 检查是否已预处理
if [ -f "$STATUS_FILE" ]; then
  echo "预处理已完成，无需重复执行"
  exit 0
fi

# 执行预处理操作
echo "开始升级前准备"
sed -i 's/bw_status="1"/bw_status="0"/g' /etc/dpkg/udeblist.xml
sed -i 's/bw_status="2"/bw_status="0"/g' /etc/dpkg/udeblist.xml
systemctl stop dbus-com.kylin.softwarectrl.service
systemctl disable dbus-com.kylin.softwarectrl.service
mv /usr/share/dbus-1/system-service/com.kylin.softwarectrl.service \
   /usr/share/dbus-1/system-service/com.kylin.softwarectrl.service.bak
chmod -w /etc/dpkg/udeblist.xml

# 标记预处理完成（需升级后脚本主动清除）
touch "$STATUS_FILE"
echo "预处理完成，状态文件已创建：$STATUS_FILE"